int carX;
int carSpeed;
int distance;
int speedOffset;
int oldOffset;

void race_loop()
{
  speedOffset=0;
  int ret = nunchuck_get_data();
  if (!ret) {
    delay(500);
    nunchuck_init();
  } else {
    int joyY=nunchuck_joyy();
    int joyX=nunchuck_joyx();
    if (joyX<64) carX--;
    if (joyX>172) carX++;
    if (joyY<64) speedOffset=-5;
    if (joyY>172) speedOffset=+5;
    carX=constrain(carX,gameMinX,gameMaxX);
    if (speedOffset != oldOffset) {
       oldOffset=speedOffset;
    }
    tone(speakerPin,120+(20*speedOffset)+random(5+speedOffset));

    if (dmd.getPixel(carX,gameMaxY-2)>0) {
      // HIT!
      Serial.println("Hit");
      noTone(speakerPin);
      display_gameover();
      display_score();
      race_setup_game();
      return;
    }
    update_scorebar(scoreY-1);
    dmd.scrollVert(-1,false);
  
    int offset = random(3)-1;
    bottomItemX=bottomItemX+offset;
    bottomItemX = constrain(bottomItemX,gameMinX,(gameMaxX-bottomItemWidth));
    for (int i=gameMinX;i<bottomItemX;i++) {
      dmd.writePixel(i,gameMinY,WHITE);
    }
    for (int i=(bottomItemX+bottomItemWidth+1);i<=gameMaxX;i++) {
      dmd.writePixel(i,gameMinY,WHITE);
    }
    dmd.writePixel(bottomItemX,gameMinY,WHITE);
    dmd.writePixel(bottomItemX+bottomItemWidth,gameMinY,WHITE);

    dmd.writePixel(carX,gameMaxY-1,WHITE);
    delay(carSpeed-speedOffset);
    distance++;
    if ((distance % 25) == 0) {
      points=distance/25;
      if ((points % 25) == 0 ){
        level++;
        bottomItemWidth--;
      }
    }
  }

}

void race_setup_game()
{
  if (gameType==NONE) return;
  Serial.println("Race");
  dmd.clearScreen(0);
  bottomItemWidth=10;
  bottomItemX=gameCentreX-(bottomItemWidth/2);
  carX=gameCentreX;
  carSpeed=30;
  points=0;
  distance=0;
  level=1;
  speedOffset=0;
  oldOffset=99;
  nunchuck_wait();
}
